;/*
cc -O -oFText Ftext.c -lmin -lcsm -lhotthg  
quit
*/

// QTPI Client in 'C' : requires csrvthg.h, libmin_a and libcsm.a
// from CSM archive

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <pd/csrvthg.h>
#include <things.h>
 
char _prog_name[] = "Files!UpASC";

char *stpcpy(char *d, const char *s)
{
    while (*d++ = *s++);
    return(d-1);
}

SendASCII(char *fn)
{
    int chn;
    if((chn = io_open(fn, 0)) > 0)
    {
        char txt[132], cbuf[270];
        int n;
        short rlen;
        char *p, *t;

        stpcpy(cbuf, "SEND ");
        while((n = io_fline (chn, -1, txt, 132)) > 0)
        {
            if(*txt == '\n')
            {
                stpcpy(cbuf+5, "\\s\\e");
            }
            else
            {
                for(t = txt, p = cbuf+5 ;*t && *t != '\n'; t++)
                {
                    if((*p++ = *t) == '\\')
                    {
                        *p++ = '\\';
                    }
                }
                stpcpy(p, "\\e");
            }
            if((p = Request("QTPI", cbuf, strlen(cbuf), &rlen)))
            {
                free(p);
            }
	} 
        io_close(chn);
    }
}

int main (int ac, char **av)
{
    char *p;
    int n = -15;
    char *sp;
    short nc;
    short mlen;
    int stdchn;

    sp = *(av + 1);		// supplied sp
    nc = *((short *) sp)++;	// channels

    if (nc)
    {
	sp += ((nc - 1) << 2);	// skip channels
	stdchn = *((long *) sp)++;	// get `stdout'
    }

    if ((n = UseSrvThg (CLNT, "QTPI")) == 0)
    {
        short rlen;
        short mlen;
        char *qs, *p;

        mlen = *((short *) sp)++;
        rlen = mlen;
        
        qs = malloc((mlen = 12 + mlen));
        p = stpcpy(qs, "SPAWN Files;");
        while(rlen--)
        {
            *p++ = *sp++;
        }

        hk_stbuf("");
	p = Request ("QTPI", qs, mlen, &rlen);
        if(p)
        {
            io_sstrg(stdchn, -1, p, rlen);
            io_sbyte(stdchn, -1, '\n');
	    free (p);
            if(*p != '\7')
            {
                char *q;
                if(hk_gtbuf(0, &q) == 0 && q )
                {
                    io_sstrg(stdchn, -1, q, strlen(q));
                    io_sbyte(stdchn, -1, '\n');
                    if(*q)
                    {
                        SendASCII(q);
                    }
                    free(q);
                }
            }
	}
	free(qs);
	FreeSrvThg (CLNT, "QTPI");
    }
    return 0;
}
int (*_Cstart) (int, char **) = main;
