;/*
cc -oqclient qclient.c -lmin -lcsm  
quit
*/

// QTPI Client in 'C' : requires csrvthg.h, libmin_a and libcsm.a
// from CSM archive

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <pd/csrvthg.h>

char _prog_name[] = "cute client";
static QLSTR_INIT (r1, "ASKT File(s) to upload\000flp1_*");

int main (int ac, char **av)
{
    char *p;
    int n = -15;
    char *sp;
    short nc;
    short mlen;
    int stdchn;

    sp = *(av + 1);		// supplied sp
    nc = *((short *) sp)++;	// channels

    if (nc)
    {
	sp += ((nc - 1) << 2);	// skip channels
	stdchn = *((long *) sp)++;	// get `stdout'
    }

    if ((n = UseSrvThg (CLNT, "QTPI")) == 0)
    {
	short rlen;

	if ((p = Request ("QTPI", r1.qs_str, r1.qs_strlen, &rlen)) && *p != 7)
	{
	    char r2[80];

	    io_sstrg (stdchn, -1, p, rlen);
	    io_sbyte (stdchn, -1, '\n');
	    strcat (strcpy (r2, "UPLOAD "), p);
	    free (p);
	    if ((p = Request ("QTPI", r2, strlen (r2), &rlen)) && *p != 7)
	    {
		io_sstrg (stdchn, -1, p, rlen);
		io_sbyte (stdchn, -1, '\n');
		free (p);
	    }
	    FreeSrvThg (CLNT, "QTPI");
	    n = 0;
	}
    }
    return n;
}
int (*_Cstart) (int, char **) = main;
