;/*
cc -O -oqclt1 qclt1.c -lmin -lcsm  
quit
*/

// QTPI Client in 'C' : requires csrvthg.h, libmin_a and libcsm.a
// from CSM archive

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <pd/csrvthg.h>

char _prog_name[] = "Qlient";
static QLSTR_INIT (r1, "SPAWN flp1_qed;flp1_qtpi_dat");

int main (int ac, char **av)
{
    char *p;
    int n = -15;
    char *sp;
    short nc;
    short mlen;
    int stdchn;

    sp = *(av + 1);		// supplied sp
    nc = *((short *) sp)++;	// channels

    if (nc)
    {
	sp += ((nc - 1) << 2);	// skip channels
	stdchn = *((long *) sp);	// get `stdout'
    }

    if ((n = UseSrvThg (CLNT, "QTPI")) == 0)
    {
        short rlen;
	p = Request ("QTPI", r1.qs_str, r1.qs_strlen, &rlen);
        if(p)
        {
            io_sstrg(stdchn, -1, p, rlen);
            io_sbyte(stdchn, -1, '\n');
	    free (p);
	}
	FreeSrvThg (CLNT, "QTPI");
    }
    return 0;
}
int (*_Cstart) (int, char **) = main;
